if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbGroup]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[tbGroup] (
		[GroupID] [int] IDENTITY(1, 1) NOT NULL ,
		[GroupName] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[Active] [bit] NOT NULL,
		[Created] [datetime] NOT NULL,
		[ConcurrencyID] [varchar] (50) NOT NULL constraint tbGroupConcurrency_UNIQ unique
	) ON [PRIMARY]
	ALTER TABLE [dbo].[tbGroup] WITH NOCHECK ADD 
		CONSTRAINT [PK_tbGroup] PRIMARY KEY  CLUSTERED 
		(
			[GroupID]
		)  ON [PRIMARY] 
	ALTER TABLE [dbo].[tbGroup] ADD 
	CONSTRAINT [DF_tbGroup_Active] DEFAULT (1) FOR [Active]
END

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbPermission]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[tbPermission] (
		[PermissionID] [int] NOT NULL ,
		[GroupID] [int] NOT NULL ,
		[SecretID] [int] NOT NULL,
		[ConcurrencyID] [varchar] (50) NOT NULL constraint tbPermissionConcurrency_UNIQ unique 
	) ON [PRIMARY]
	ALTER TABLE [dbo].[tbPermission] WITH NOCHECK ADD 
	CONSTRAINT [PK_tbPermission] PRIMARY KEY  CLUSTERED 
	(
		[PermissionID]
	)  ON [PRIMARY] 
	ALTER TABLE [dbo].[tbPermission] ADD 
	CONSTRAINT [FK_tbPermission_Group] FOREIGN KEY 
	(
		[GroupID]
	) REFERENCES [dbo].[tbGroup] (
		[GroupID]
	) ON DELETE CASCADE  ON UPDATE CASCADE ,
	CONSTRAINT [FK_tbPermission_Secret] FOREIGN KEY 
	(
		[SecretID]
	) REFERENCES [dbo].[tbSecret] (
		[SecretID]
	) ON UPDATE CASCADE 
END

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbUserGroup]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[tbUserGroup] (
		[UserID] [int] NOT NULL ,
		[GroupID] [int] NOT NULL,
		[ConcurrencyID] [varchar] (50) NOT NULL constraint tbUserGroupConcurrency_UNIQ unique
	) ON [PRIMARY]
	
	ALTER TABLE [dbo].[tbUserGroup] WITH NOCHECK ADD 
	CONSTRAINT [PK_tbUserGroup] PRIMARY KEY  CLUSTERED 
	(
		[UserID],
		[GroupID]
	)  ON [PRIMARY]
	
	ALTER TABLE [dbo].[tbUserGroup] ADD 
	CONSTRAINT [FK_tbUserGroup_Group] FOREIGN KEY 
	(
		[GroupID]
	) REFERENCES [dbo].[tbGroup] (
		[GroupID]
	) ON UPDATE CASCADE ,
	CONSTRAINT [FK_tbUserGroup_User] FOREIGN KEY 
	(
		[UserID]
	) REFERENCES [dbo].[tbUser] (
		[UserID]
	) ON UPDATE CASCADE 

END